#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#include "mu.h"


/* UNSAFE: this handler uses non-async-signal-safe functions */
static void
sigint_handler(int sig)
{
    static int n_sigint;

    if (sig == SIGINT) {
        n_sigint++;
        printf("[caught SIGINT (%d total)]\n", n_sigint);
        return;
    }

    printf("[caught SIGQUIT -- goodbye!]\n");
    exit(0);
}


int
main(void)
{
    /* establish same handler for SIGINT (CTRL-C) and SIGQUIT (CTRL-\) */
    if (signal(SIGINT, sigint_handler) == SIG_ERR)
        mu_die_errno(errno, "signal");

    if (signal(SIGQUIT, sigint_handler) == SIG_ERR)
        mu_die_errno(errno, "signal");

    /* loop forever, waiting for signals */
    while (1) {
        /* 
         * block (suspend the process' execution) until either a signal is caught
         * or an unhandled signal kills the process
         */
        pause();
    }

    return 0;
}
